package com.gic.plug.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.plug.web.vo.widget.StoreWidgetInterfaceVO;
import com.gic.store.dto.StoreDictDTO;
import com.gic.store.service.StoreDictApiService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/store-type")
public class StoreTypeController {
    @Autowired
    private StoreDictApiService storeDictApiService;

    @RequestMapping("list-storetype")
    @ResponseBody
    public RestResponse listStoreType(){
        Integer enterpriseId = UserDetailUtils.getUserDetail().getEnterpriseId();
        ServiceResponse<List<StoreDictDTO>> serviceResponse = this.storeDictApiService.listStoreType(enterpriseId);
        if (serviceResponse.isSuccess()) {
            return RestResponse.success(transferToVo(serviceResponse.getResult()));
        } else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    @RequestMapping("list-storestatus")
    @ResponseBody
    public RestResponse listStoreStatus(){
        Integer enterpriseId = UserDetailUtils.getUserDetail().getEnterpriseId();
        ServiceResponse<List<StoreDictDTO>> serviceResponse = this.storeDictApiService.listStoreStatus(enterpriseId);
        if(serviceResponse.isSuccess()){
            return RestResponse.success(transferToVo(serviceResponse.getResult()));
        }else {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
    }

    private List<StoreWidgetInterfaceVO> transferToVo(List<StoreDictDTO> list) {
        List<StoreWidgetInterfaceVO> voList = new ArrayList<>();
        if (CollectionUtils.isNotEmpty(list)) {
            voList = list.stream()
                    .map(e -> new StoreWidgetInterfaceVO().setLabel(e.getKey()).setValue(e.getValue().toString()))
                    .collect(Collectors.toList());
        }
        return voList;
    }
}
